# ShellRelayService

> The ShellRelayService methods and their request and response messages.

Source: https://engramsfactory.com/docs/api/shell-relay/

Generated from [`session.proto`](https://github.com/cortexapps/engrams/blob/main/crates/engram-protocol/proto/engram/app/v1/session.proto). Every method is
`POST /rpc/engram.app.v1.ShellRelayService/<Method>` with a JSON or protobuf body and an
`x-api-key` header.

## Methods

| Method | Request | Response |
|---|---|---|
| `Relay` | [`RelayShellRequest`](#relayshellrequest) (stream) | [`RelayShellResponse`](#relayshellresponse) (stream) |

## Messages

### RelayShellRequest

| Field | Type |
|---|---|
| `open` | [`ShellOpen`](#shellopen) (one of frame) |
| `text` | `string` (one of frame) |
| `binary` | `bytes` (one of frame) |
| `ping` | `bytes` (one of frame) |
| `pong` | `bytes` (one of frame) |
| `close` | [`ShellClose`](#shellclose) (one of frame) |

### RelayShellResponse

| Field | Type |
|---|---|
| `text` | `string` (one of frame) |
| `binary` | `bytes` (one of frame) |
| `ping` | `bytes` (one of frame) |
| `pong` | `bytes` (one of frame) |
| `close` | [`ShellClose`](#shellclose) (one of frame) |

### ShellClose

| Field | Type |
|---|---|
| `code` | `uint32` |
| `reason` | `string` |

### ShellOpen

| Field | Type |
|---|---|
| `session_id` | `string` |
